      subroutine plw2j(imode,isel)
      implicit none

      INCLUDE 'inclk.h'
      INCLUDE 'grchad.inc'

      INTEGER MXDIM,NDMX,NDIM,NWILD,IG,NCALL,ITMX1,ITMX2
      DOUBLE PRECISION XL,XU,ACC1,ACC2
      PARAMETER (MXDIM = 50, NDMX = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2

      INTEGER JPROC
      COMMON /AMJPRC/JPROC

      CHARACTER GRCPROC*40
      COMMON/GRCCHAR/GRCPROC

      INTEGER i,imode,isel
      real*8  xsn(10),rna
      integer imrg,ijrg


C...Decide subprocess ID.
      if (imode.eq.1) then
         ijrg = 423
C...Include all configuration in W + 3jets.
         imrg = 7
         xsn(2) = 0.50d0        ! 425
         xsn(3) = 0.60d0        ! 426
         xsn(4) = 0.76d0        ! 427
         xsn(5) = 0.82d0        ! 428
         xsn(6) = 0.88d0        ! 429
         xsn(7) = 0.94d0        ! 430
C...Inclusive heavy flavor production.
         if (igjflv(7).eq.0) then
            imrg = 6
            xsn(2) = 0.30d0     ! 425
            xsn(3) = 0.46d0     ! 427
            xsn(4) = 0.76d0     ! 428
            xsn(5) = 0.84d0     ! 429
            xsn(6) = 0.92d0     ! 430
         endif
         rna = xrun(11)
         xsn(1) = 0.0d0
         xsn(imrg+1) = 1.0d0
         do i = 1,imrg
            if (rna.gt.xsn(i).and.rna.le.xsn(i+1)) then
               gpri(10) = (rna-xsn(i))/(xsn(i+1)-xsn(i))
               yacob = yacob/(xsn(i+1)-xsn(i))
               jproc = i + ijrg
            endif
         enddo
C...Inclusive heavy flavor production.
         if (igjflv(7).eq.0) then
            if (jproc.eq.429) jproc = 430
            if (jproc.eq.428) jproc = 429
            if (jproc.eq.427) jproc = 428
            if (jproc.eq.426) jproc = 427
         endif

C...Set dimension and process character.
      else if (imode.eq.2) then
         ndim = 13
         if (isel.eq.102) grcproc = 'pp(bar)->W(2f) + 2 jets'
         if (isel.eq.424) grcproc = 'qg -> W(2f) + qg(ELWK2,QCD2)'
         if (isel.eq.425) grcproc = 'qq -> W(2f) + qq(ELWK2,QCD2)'
         if (isel.eq.426) grcproc = 'qq -> W(2f) + gg(ELWK2,QCD2)'
         if (isel.eq.427) grcproc = 'gg -> W(2f) + qq(ELWK2,QCD2)'
         if (isel.eq.428) grcproc = 'qq -> W(2f) + qq(ELWK2,QCD2)'
         if (isel.eq.429) grcproc = 'qq -> W(2f) + qq(ELWK2,QCD2)'
         if (isel.eq.430) grcproc = 'qq -> W(2f) + qq(ELWK2,QCD2)'

C...Initialize kinematic parameter.
      else if (imode.eq.3) then
         mxreg = 1
         ktype = 2401
         cxtype = 123456
         gtau(1) = 1
         gtau(14) = 2
         gyst(1) = 1
         gyst(14) = 5
         gcos3(1) = 1
         gcos3(14) = 4
         gq12(1) = 1
         gq12(2) = 2.0d0**2
         gq12(14) = 10
         gq22(1) = 1
         gq22(2) = 2.0d0**2
         gq22(14) = 2

         if (igjflv(1)+igjflv(2)+igjflv(3)+igjflv(4)
     $        +igjflv(5)+igjflv(7).eq.0.and.igjflv(6).eq.1) then
            ktype = 2404
            gtau(2) = amuq(3)**2/grcecm**2
            gq22(2) = amuq(3)**2
         endif

C...Set flavor and if necessary, decide weight of each phase space.
      else if (imode.eq.4) then
         isel = 1
      endif

      return
      end
